<template>
  <div>
    <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
        <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
          <a-row :gutter="24">
                <a-col :lg="6" >
                    <a-form-item :label="searchFormSchema[0].label">
                        <JInput type="like" placeholder="请输入" v-model:value="queryParam[searchFormSchema[0].field]" />
                    </a-form-item>
                </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[1].label">
                        <JDictSelectTag v-model:value="queryParam[searchFormSchema[1].field]" placeholder="请选择" dictCode="metrictype"  />
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[2].label">
                        <JDictSelectTag v-model:value="queryParam[searchFormSchema[2].field]" placeholder="请选择" dictCode="colletway"  />
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                    <a-form-item>
                    <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                    <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" style="margin-left: 8px">重置</a-button>
                    </a-form-item>
                  </a-col>
            </a-row>
        </a-form>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined">新建</a-button>
          <a-button v-show="showBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button v-show="showBtn"  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-show="showBtn" v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
      <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'metricDesc'">
              <JEllipsisFormat :value="record.metricDesc" :length="60"/>
          </template>
          <template v-else-if="column.key === 'metricName'">
              <JEllipsisFormat :value="record.metricName" :length="60"/>
          </template>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
  </div>
    <!-- 表单区域 -->
    <StMetricModal @register="registerModal" @success="handleSuccess"></StMetricModal>
  </div>
</template>

<script lang="ts" name="standardlib-controlactivity-StMetricList" setup>
import { onMounted, reactive, ref, toRaw, unref } from 'vue';
import { useRoute } from 'vue-router';
import JEllipsisFormat from '../components/JEllipsisFormat.vue';
import { batchDelete, deleteOne, getExportUrl, getImportUrl, list,addFromStMetric} from './StMetric.api';
import { columns, searchFormSchema } from './StMetric.data';
import StMetricModal from './components/StMetricModal.vue';
import { JDictSelectTag, JInput } from '/@/components/Form';
import { useModal } from '/@/components/Modal';
import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';
  const route = useRoute();
  const showBtn = ref(false)
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: 'st_metric',
           api: list,
           columns,
           canResize:false,
           showTableSetting: false,
           useSearchForm: false,
           
           actionColumn: {
               width: 250,
               fixed:'right',
            },
            beforeFetch(params) {
            params = Object.assign(params,{ column: 'updatedTime', order: 'desc' })
         },
      },
       exportConfig: {
            name:"st_metric",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {setProps,reload},{ rowSelection, selectedRowKeys }] = tableContext
//-----自定义查询----begin--------
const labelCol = reactive({
  xs: {span: 24},
  sm: {span: 8},
})
const wrapperCol = reactive({
    xs: {span: 24},
    sm: {span: 16},
})
const queryParam = reactive({
});
function initParam() {
  const schemas = unref(searchFormSchema);
  schemas.forEach((item) => {
    queryParam[item.field] = ''
  });
}
initParam()
function searchQuery(){
    setProps({searchInfo:toRaw(queryParam)});
    reload()
}
function searchReset(){
    //Object.assign(queryParam,{ name: '',age_begin: '',age_end: '',sex: '',id: ''});
    initParam()
    reload();
}
onMounted(()=>{
  const bizNo = toRaw(route.query).bizNo
  if(!!bizNo){
  // const queryName = toRaw(route.query).bizNo
  setProps({searchInfo:{metricNo:bizNo}});
    //reload()
  }
})
//自定义查询----end--------- 
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
        {
           label: '删除',
           color: 'error',
           popConfirm: {
             title: '你确定要删除选中的指标吗？',
             confirm: handleDelete.bind(null, record),
           }
         },
         {
           label: '修改',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '添加到监测库',
           onClick: handleAddMonitorLib.bind(null, record),
         },
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         },
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
       ]
   }

   async function handleAddMonitorLib(record){
    await addFromStMetric(record);
  }


</script>

<style scoped>

</style>